<?php

/** 
*
* @mod package		Download MOD 6.x Installation Removal Script 
* @file				dl_mod_install_remove.php 1 2009/02/13 OXPUS
* @copyright		(c) 2009 oxpus (Karsten Ude) <webmaster@oxpus.de> http://www.oxpus.de
* @license			http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/*
* connect to phpBB
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/acp/acp_modules.' . $phpEx);

/*
* session management
*/
$user->session_begin();
$auth->acl($user->data);
$user->setup();
$user->add_lang('acp/modules');

if (!($auth->acl_get('a_') && $user->data['is_registered']))
{
	trigger_error($user->lang['NOT_AUTHORISED'], E_USER_WARNING);
}

// At the very first switch off the sql error routine to be sure to continue until the script ends
$db->return_on_error = true;

$sql = array();

// Dropping tables used by the Download MOD
$sql[] = "DROP TABLE " . $table_prefix . "downloads";
$sql[] = "DROP TABLE " . $table_prefix . "downloads_cat";
$sql[] = "DROP TABLE " . $table_prefix . "dl_auth";
$sql[] = "DROP TABLE " . $table_prefix . "dl_comments";
$sql[] = "DROP TABLE " . $table_prefix . "dl_ratings";
$sql[] = "DROP TABLE " . $table_prefix . "dl_stats";
$sql[] = "DROP TABLE " . $table_prefix . "dl_config";
$sql[] = "DROP TABLE " . $table_prefix . "dl_ext_blacklist";
$sql[] = "DROP TABLE " . $table_prefix . "dl_banlist";
$sql[] = "DROP TABLE " . $table_prefix . "dl_favorites";
$sql[] = "DROP TABLE " . $table_prefix . "dl_notraf";
$sql[] = "DROP TABLE " . $table_prefix . "dl_hotlink";
$sql[] = "DROP TABLE " . $table_prefix . "dl_bug_tracker";
$sql[] = "DROP TABLE " . $table_prefix . "dl_bug_history";

// Run the previous defined sql statements
for ($i = 0; $i < sizeof($sql); $i++)
{
	$db->sql_query($sql[$i]);
	echo "Dropping: " . $sql[$i] . "<br />";
}

unset ($sql);
echo '<hr />';

// Dropping group traffic settings
$sql = "ALTER TABLE " . $table_prefix . "groups DROP COLUMN group_dl_auto_traffic";

// Run the previous defined sql statements
$db->sql_query($sql);
echo "Dropping: " . $sql . "<br />";

unset ($sql);
echo '<hr />';

$sql = array();

// Dropping user settings
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_allow_new_download_email";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_allow_fav_download_email";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_allow_new_download_popup";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_allow_fav_download_popup";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_dl_update_time";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_new_download";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_traffic";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_dl_note_type";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_dl_sort_fix";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_dl_sort_opt";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_dl_sort_dir";
$sql[] = "ALTER TABLE " . $table_prefix . "users DROP COLUMN user_dl_sub_on_index";

// Run the previous defined sql statements
for ($i = 0; $i < sizeof($sql); $i++)
{
	$db->sql_query($sql[$i]);
	echo "Dropping: " . $sql[$i] . "<br />";
}

unset ($sql);

// Initiate the module management system
$modules = new acp_modules();

// Initiate the acp module data
$modules_acp_array = array(
	'ACP_USER_OVERVIEW',
	'DL_ACP_CONFIG_MANAGEMENT',
	'DL_ACP_TRAFFIC_MANAGEMENT',
	'DL_ACP_CATEGORIES_MANAGEMENT',
	'DL_ACP_FILES_MANAGEMENT',
	'DL_ACP_PERMISSIONS',
	'DL_ACP_STATS_MANAGEMENT',
	'DL_ACP_BANLIST',
	'DL_EXT_BLACKLIST',
	'DL_MANAGE',
	'DOWNLOADS',
);

$modules->module_class = 'acp';

echo '<hr />';

// Remove each acp module
for ($i = 0; $i < sizeof($modules_acp_array); $i++)
{
	$sql = "SELECT module_id FROM " . MODULES_TABLE . "
		WHERE module_class = 'acp'
			AND module_langname = '" . $modules_acp_array[$i] . "'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$module_id = $row['module_id'];
	$db->sql_freeresult($result);

	echo 'Delete ACP Module: ' . $modules_acp_array[$i] . '<br />'; 
	if ($module_id)
	{
		$modules->delete_module($module_id);
	}
}

unset ($modules_acp_array);

// Initiate the ucp module data
$modules_ucp_array = array(
	'DL_CONFIG',
	'DL_FAVORITE',
	'DOWNLOADS',
);

$modules->module_class = 'ucp';

echo '<hr />';

// Remove each ucp module
for ($i = 0; $i < sizeof($modules_ucp_array); $i++)
{
	$sql = "SELECT module_id FROM " . MODULES_TABLE . "
		WHERE module_class = 'ucp'
			AND module_langname = '" . $modules_ucp_array[$i] . "'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$module_id = $row['module_id'];
	$db->sql_freeresult($result);

	echo 'Delete UCP Module: ' . $modules_ucp_array[$i] . '<br />'; 
	if ($module_id)
	{
		$modules->delete_module($module_id);
	}
}

unset ($modules_ucp_array);

// Initiate the permission data
$module_auth = array(
	'a_dl_overview',
	'a_dl_config',
	'a_dl_traffic',
	'a_dl_categories',
	'a_dl_files',
	'a_dl_permissions',
	'a_dl_stats',
	'a_dl_banlist',
	'a_dl_blacklist',
	'a_dl_toolbox',
);

echo '<hr />Fetching all auth_option_ids ...';

// First fetch all existing auth_option_ids
$auth_option_ids = '';
for ($i = 0; $i < sizeof($module_auth); $i++)
{
	$sql = "SELECT auth_option_id FROM " . ACL_OPTIONS_TABLE . "
		WHERE auth_option = '" . $module_auth[$i] . "'";
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		$auth_option_ids .= ($auth_option_ids != '') ? ', ' . $row['auth_option_id'] : $row['auth_option_id'];
	}

	$db->sql_freeresult($result);
}

echo '<br />Dropping auth_option_ids from auth tables ...';

if ($auth_option_ids)
{
	// Remove all group auth settings
	$sql = "DELETE FROM " . ACL_GROUPS_TABLE . "
		WHERE auth_option_id IN ($auth_option_ids)";
	$db->sql_query($sql);

	// Remove all user auth settings
	$sql = "DELETE FROM " . ACL_USERS_TABLE . "
		WHERE auth_option_id IN ($auth_option_ids)";
	$db->sql_query($sql);

	// Remove all user auth settings
	$sql = "DELETE FROM " . ACL_OPTIONS_TABLE . "
		WHERE auth_option_id IN ($auth_option_ids)";
	$db->sql_query($sql);
}

echo '<br />Purge the cache ...';

// At least purge the cache
$cache->purge();

echo '<hr />Congratulations.';
echo '<br />Your database is now cleaned up from all changes made by the installation script of the Download MOD.';
echo '<br />You can now try to reinstall the MOD or use your forum as it is.';
echo '<br /><b style="color: #ff0000">Please remove this file <u>now</u> to prevent malfunctions after a possible reinstallation of the Download MOD!!</b>';
echo '<br />At least please check all remaining acp and ucp modules and fix them with the module management in the administration panel if needed.';
echo '<br /><br />This script is now at the end ...';  

?>